package element

import (
	"git.nspix.com/golang/pgenr/internal/pool"
)

type (
	Element interface {
		Html() string
	}

	Attrs map[string]string
)

func renderTag(tag string, attrs Attrs, content string) string {
	br := pool.Get()
	defer pool.Put(br)
	br.WriteString("<" + tag)
	if len(attrs) > 0 {
		for k, v := range attrs {
			br.WriteString(" " + k + "=\"" + v + "\" ")
		}
	}
	br.WriteString(">")
	br.WriteString(content)
	br.WriteString("</" + tag + ">")
	return br.String()
}

func beginTag(tag string, attrs Attrs) string {
	br := pool.Get()
	defer pool.Put(br)
	br.WriteString("<" + tag)
	if len(attrs) > 0 {
		for k, v := range attrs {
			br.WriteString(" " + k + "=\"" + v + "\" ")
		}
	}
	br.WriteString(">")
	return br.String()
}

func endTag(tag string) string {
	br := pool.Get()
	defer pool.Put(br)
	br.WriteString("</" + tag + ">")
	return br.String()
}
